﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class TheWord : MonoBehaviour {

    TextMesh tm;
    MeshRenderer mr;
	// Use this for initialization
	void Start () {
        tm = GetComponent<TextMesh>();
        mr = GetComponent<MeshRenderer>();
	}
    public ParticleSystem bloodsystem;
    public GameObject animal;
    public GameObject cube;
    public GameObject undercube;
    public GameObject duplicate;
    public TextMesh duplicatetm;
    public MeshRenderer duplicatemr;
    public AudioClip ac;
    public GameObject hairparticles;
    public GameObject mirror;
    public TextMesh mirrortm;
    public MeshRenderer mirrormr;

    float h = 0;
    float h2 = 0;
    public Font[] fonts;
    public int fontindex;
    public string toappend = "";
    public string toprepend = "";
    public AudioClip xylophone;
	// Update is called once per frame
	void Update () {
        if (Input.GetKeyDown(KeyCode.A))
        {
            toappend += "append";
            tm.text =  toprepend + "append"+toappend;
        } if (Input.GetKey(KeyCode.B))
        {
            tm.text =  toprepend + "background"+toappend;
            h2 =(h2+ Time.deltaTime/2)%1.0f;
            Camera.main.backgroundColor = Color.HSVToRGB(h2, 0.5f, 1);
        } if (Input.GetKey(KeyCode.C)){            
            tm.text =  toprepend + "color"+toappend;
            h =(h+ Time.deltaTime)%1.0f;
            tm.color = Color.HSVToRGB(h, 1, 1);
                
        } if (Input.GetKey(KeyCode.D))
        {
            tm.text =  toprepend + "double"+toappend;
            duplicate.SetActive(true);
        } if (Input.GetKey(KeyCode.E))
        {
            tm.text =  toprepend + "expand"+toappend;
            var s = transform.localScale;
            s.x *= 1.0f+Time.deltaTime;
            transform.localScale = s;
        } if (Input.GetKeyDown(KeyCode.F))
        {
            tm.text =  toprepend + "font"+toappend;
            fontindex = (fontindex + 1) % fonts.Length;
            tm.font = fonts [fontindex];
            mr.material = fonts [fontindex].material;
            duplicatetm.font = fonts [fontindex];
            duplicatemr.material = fonts [fontindex].material;
            mirrortm.font = fonts [fontindex];
            mirrormr.material = fonts [fontindex].material;


        } if (Input.GetKey(KeyCode.G))
        {
            tm.text = toprepend +  "grow"+toappend;
            gameObject.transform.localScale = gameObject.transform.localScale * (1 + Time.deltaTime);
        } if (Input.GetKeyDown(KeyCode.H))
        {
            tm.text = toprepend +  "hair"+toappend;
            hairparticles.SetActive(!hairparticles.activeSelf);
        } if (Input.GetKeyDown(KeyCode.I))
        {
            tm.text =  toprepend + "invert"+toappend;
            var scale = transform.localScale;
            scale.x = -scale.x;
            transform.localScale = scale;
            Debug.Log(scale+","+ transform.localScale);
        } if (Input.GetKey(KeyCode.J))
        {
            tm.text= toprepend + "jump"+toappend;
            var p = transform.localPosition;
            p.y=Mathf.Sin(Time.time*10.0f)/2;
            transform.localPosition=p;
        } if (Input.GetKeyDown(KeyCode.K))
        {

            tm.text= toprepend + "kill"+toappend;
            bloodsystem.Emit(100);
        } if (Input.GetKey(KeyCode.L))
        {
            tm.text= toprepend + "loop"+toappend;
            var p = transform.localPosition;
            p.y=Mathf.Sin(Time.time*10.0f)/2;
            p.x=Mathf.Cos(Time.time*10.0f)/2;
            transform.localPosition=p;
        } if (Input.GetKey(KeyCode.M))
        {
            tm.text =  toprepend + "mirror"+toappend;
            mirror.SetActive(true);
        } if (Input.GetKey(KeyCode.N))
        {
            tm.text =  toprepend + "narrow"+toappend;
            var s = transform.localScale;
            s.x *= 1.0f-Time.deltaTime;
            transform.localScale = s;
        } if (Input.GetKey(KeyCode.O))
        {
            tm.text =  toprepend + "over"+toappend;
            undercube.SetActive(true);
        } if (Input.GetKeyDown(KeyCode.P))
        {

            toprepend +=  toprepend + "prepend";
            tm.text = toprepend + "prepend"+toappend;
        } if (Input.GetKey(KeyCode.Q))
        {
            tm.text =  toprepend + "quiver"+toappend;
            transform.position = Random.onUnitSphere/2;
        } if (Input.GetKey(KeyCode.R))
        {
            tm.text =  toprepend + "rotate"+toappend;
            gameObject.transform.RotateAround(Vector3.forward, Time.deltaTime * 10.0f);
        } if (Input.GetKey(KeyCode.S))
        {
            tm.text =  toprepend + "shrink"+toappend;
            gameObject.transform.localScale = gameObject.transform.localScale * (1 - Time.deltaTime);
        } if (Input.GetKey(KeyCode.T))
        {
            tm.text =  toprepend + "tilt"+toappend;
            gameObject.transform.RotateAround(-Vector3.right, Time.deltaTime);
        } if (Input.GetKey(KeyCode.U))
        {
            tm.text =  toprepend + "under"+toappend;
            cube.SetActive(true);
        } if (Input.GetKey(KeyCode.V))
        {
            tm.text =  toprepend + "vertical"+toappend;
            var s = transform.localScale;
            s.y *= 1.0f+Time.deltaTime;
            transform.localScale = s;
        } if (Input.GetKey(KeyCode.W))
        {
            tm.text= toprepend + "wiggle"+toappend;
            var p = transform.localPosition;
            p.x=Mathf.Sin(Time.time*25.0f)/2;
            transform.localPosition=p;
        } if (Input.GetKeyDown(KeyCode.X))
        {
            var asource = Camera.main.GetComponent<AudioSource>();
            asource.pitch = Random.Range(0.1f, 3.0f);
            asource.Stop();
            asource.clip = xylophone;
            asource.Play();
            tm.text= toprepend + "xylophone"+toappend;
        } if (Input.GetKeyDown(KeyCode.Y))
        {
            tm.text= toprepend + "yell"+toappend;
            AudioSource.PlayClipAtPoint(ac, Vector3.zero);
        } if (Input.GetKeyDown(KeyCode.Z))
        {
            tm.text= toprepend + "zoo"+toappend;
            var gm = Instantiate(animal, Random.insideUnitSphere * 7, Quaternion.Euler(90.0f,0,0));
            gm.transform.parent = transform;
        } 


        duplicatetm.text = tm.text;
        duplicatetm.color = tm.color;


        mirrortm.text = tm.text;
        mirrortm.color = tm.color;
	}
}
